## rock-master-20.01-slam-hogman 0.20121001

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
find_package(Rock)

rock_init(hogman 1.0)

set(HOGMAN_INSTALL include/hogman/aislib)

include_directories(. aislib)
add_subdirectory(aislib)

=== Makefile ===
-include ./global.mk

SUBDIRS_EXTERNAL = EXTERNAL
SUBDIRS_AISLIB	 = aislib
	
SUBDIRS = 	$(SUBDIRS_EXTERNAL)\
		slam_parser $(SUBDIRS_AISLIB)

LDFLAGS+=
CPPFLAGS+=

-include ./build_tools/Makefile.subdirs

=== EXTERNAL/Makefile ===
-include ../global.mk

SUBDIRS += csparse

-include ../build_tools/Makefile.subdirs

=== aislib/CMakeLists.txt ===
#
# add the csparse stuff here, since convenience libraries
# are not really supported in cmake yet
#
set(CSPARSE_DIR ${PROJECT_SOURCE_DIR}/EXTERNAL/csparse)

file(GLOB CSPARSE_FILES 
    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    ${CSPARSE_DIR}/*.c)

install(FILES
    ${CSPARSE_DIR}/cs.h
    DESTINATION ${HOGMAN_INSTALL}/EXTERNAL/csparse)

rock_library(hogman
    graph/dijkstra.cpp
    graph/graph.cpp
    graph/loadEdges3d.cpp
    graph_optimizer/graph_optimizer2d_aux.cpp
    graph_optimizer_hogman/csparse_helper.cpp
    graph/posegraph2d.cpp
    graph/posegraph3d.cpp
    stuff/filesys_tools.cpp
    stuff/runtime_error.cpp
    stuff/string_tools.cpp
    ${CSPARSE_FILES}
)

install(FILES 
    graph/dijkstra.h
    graph/graph.h
    graph/loadEdges3d.h
    graph/posegraph2d.h
    graph/posegraph3d_gradient.h
    graph/posegraph3d.h
    graph/posegraph.h
    graph/posegraph.hpp
    DESTINATION ${HOGMAN_INSTALL}/graph)

install(FILES 
    graph_optimizer/graph_optimizer2d_aux.h
    graph_optimizer/graph_optimizer2d.h
    graph_optimizer/graph_optimizer3d.h
    graph_optimizer/graph_optimizer.h
    graph_optimizer_hogman/csparse_helper.h
    graph_optimizer_hogman/graph_optimizer2d_chol.h
    graph_optimizer_hogman/graph_optimizer2d_hchol.h
    graph_optimizer_hogman/graph_optimizer3d_chol.h
    graph_optimizer_hogman/graph_optimizer3d_hchol.h
    graph_optimizer_hogman/graph_optimizer_chol.h
    graph_optimizer_hogman/graph_optimizer_hchol.h
    graph_optimizer/graph_optimizer.hpp
    graph_optimizer_hogman/graph_optimizer_chol.hpp
    graph_optimizer_hogman/graph_optimizer_hchol_aux.hpp
    graph_optimizer_hogman/graph_optimizer_hchol_batch.hpp
    graph_optimizer_hogman/graph_optimizer_hchol.hpp
    graph_optimizer_hogman/graph_optimizer_hchol_incremental.hpp
    DESTINATION ${HOGMAN_INSTALL}/graph_optimizer)

install(FILES 
    math/angle.h
    math/axis_angle.h
    math/matrix_n.h
    math/quaternion.h
    math/rotation_matrix.h
    math/transformation.h
    math/vector_n.h
    math/axis_angle.hpp
    math/matrix_n.hpp
    math/quaternion.hpp
    math/rotation_matrix.hpp
    math/vector_n.hpp
    DESTINATION ${HOGMAN_INSTALL}/math)

install(FILES 
    stuff/array_allocator.h
    stuff/color_macros.h
    stuff/filesys_tools.h
    stuff/macros.h
    stuff/os_specific.h
    stuff/runtime_error.h
    stuff/string_tools.h
    DESTINATION ${HOGMAN_INSTALL}/stuff)

rock_executable(hogman2d
    graph_optimizer_hogman/hogman2d.cpp
    DEPS hogman 
)

rock_executable(hogman3d
    graph_optimizer_hogman/hogman3d.cpp
    DEPS hogman 
)

=== aislib/Makefile ===
-include ../global.mk

SUBDIRS += stuff \
           math \
           graph \
           graph_optimizer \
           graph_optimizer_hogman

SUBDIRS += hogman_interactive

ifeq	($(LINUX),1)
SUBDIRS += graph_viewer
endif

-include ../build_tools/Makefile.subdirs

=== slam_parser/Makefile ===
-include ../global.mk

SUBDIRS += parser interface 

-include ../build_tools/Makefile.subdirs

=== EXTERNAL/csparse/Makefile ===
-include ../../global.mk

COBJS = cs_add.o\
cs_amd.o\
cs_chol.o\
cs_cholsol.o\
cs_compress.o\
cs_counts.o\
cs_cumsum.o\
cs_dfs.o\
cs_dmperm.o\
cs_droptol.o\
cs_dropzeros.o\
cs_dupl.o\
cs_entry.o\
cs_ereach.o\
cs_etree.o\
cs_fkeep.o\
cs_gaxpy.o\
cs_happly.o\
cs_house.o\
cs_ipvec.o\
cs_leaf.o\
cs_load.o\
cs_lsolve.o\
cs_ltsolve.o\
cs_lu.o\
cs_lusol.o\
cs_malloc.o\
cs_maxtrans.o\
cs_multiply.o\
cs_norm.o\
cs_permute.o\
cs_pinv.o\
cs_post.o\
cs_print.o\
cs_pvec.o\
cs_qr.o\
cs_qrsol.o\
cs_randperm.o\
cs_reach.o\
cs_scatter.o\
cs_scc.o\
cs_schol.o\
cs_spsolve.o\
cs_sqr.o\
cs_symperm.o\
cs_tdfs.o\
cs_transpose.o\
cs_updown.o\
cs_usolve.o\
cs_util.o\
cs_utsolve.o

CCOPTS += -Wall -O3 -fPIC
LDFLAGS += -lm

LDFLAGS+=  
CPPFLAGS+= 

LD = $(CC)
CXX = $(CC)

-include ../../build_tools/Makefile.generic-shared-object

=== aislib/graph/Makefile ===
-include ../../global.mk

OBJS = graph.o dijkstra.o posegraph3d.o loadEdges3d.o posegraph2d.o
 
LDFLAGS += -l$(LIB_PREFIX)stuff -l$(LIB_PREFIX)math
CPPFLAGS+= 

-include ../../build_tools/Makefile.generic-shared-object

=== aislib/graph_optimizer/Makefile ===
-include ../../global.mk

OBJS= graph_optimizer2d_aux.o

#this is for safe type checking
#CPPFLAGS += -D"_MY_CAST_=dynamic_cast"

LDFLAGS+=  -lm -l$(LIB_PREFIX)stuff -l$(LIB_PREFIX)graph 
CPPFLAGS+= 

-include ../../build_tools/Makefile.generic-shared-object

=== aislib/graph_optimizer_hogman/Makefile ===
-include ../../global.mk

OBJS  =	csparse_helper.o

APPS  = hogman2d hogman3d


CPPFLAGS += -D"_MY_CAST_=reinterpret_cast"

#this is for safe type checking
#CPPFLAGS += -D"_MY_CAST_=dynamic_cast"

LIBS += -l$(LIB_PREFIX)graph_optimizer -l$(LIB_PREFIX)graph \
	-l$(LIB_PREFIX)stuff  -l$(LIB_PREFIX)math -l$(LIB_PREFIX)csparse

CPPFLAGS += -I$(ROOTDIR)/aislib

-include ../../build_tools/Makefile.generic-shared-object

=== aislib/graph_viewer/Makefile ===
-include ../../global.mk

OBJS  = primitives.o pose_graph_vis3d.o qgl_graph_viewer.o
OBJS += matrix4x4.o vrml_output.o vector4.o main_widget.o
APPS = graph_viewer

LDFLAGS  += -lqglviewer-qt4 -lGLU -lGL -l$(LIB_PREFIX)graph -lpthread
LDFLAGS+= $(QT_LIB)
CPPFLAGS+= $(QT_INCLUDE)
CPPFLAGS+= -I$(ROOTDIR)/EXTERNAL

-include ../../build_tools/Makefile.generic-shared-object

=== aislib/hogman_interactive/Makefile ===
-include ../../global.mk

OBJS= hogman_slam_interface.o

APPS= hogman_online

LDFLAGS+= -l$(LIB_PREFIX)interface
LDFLAGS+= -l$(LIB_PREFIX)parser
LDFLAGS+= -l$(LIB_PREFIX)graph_optimizer_hogman
LDFLAGS+= -l$(LIB_PREFIX)graph
LDFLAGS+= -l$(LIB_PREFIX)csparse


CPPFLAGS+= -I$(ROOTDIR)/aislib

-include ../../build_tools/Makefile.generic-shared-object

=== debian/changelog ===
rock-master-20.01-slam-hogman (0.20121001-1~xenial) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/OpenSLAM-org/openslam_hog-man.git
  * branch: refs/heads/master
  * commit: a5181578033a595ebec8cd7fa47585efb1fa563b
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Sun, 09 Feb 2020 04:36:01 +0100

=== debian/control ===
Source: rock-master-20.01-slam-hogman
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, cmake, rock-master-20.01-base-cmake
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.01-slam-hogman
Architecture: any
Depends: ${shlibs:Depends}, rock-master-20.01-base-cmake, cmake
Description: HOG-Man - Hierarchical Optimization for Pose Graphs on Manifolds
 HOG-Man is an optimization approach for graph-based SLAM. It provides a
  highly efficient error minimization procedure that considers the the
  underlying space is a manifold and not a Euclidian space. It
  furthermore generates a hierarchy of pose-graphs which is used perform
  the operations during online mapping in a highly efficient way. The
  approach works in 2D and 3D.

=== debian/rules ===
#!/usr/bin/make -f

# BEGIN ENVIRONMENT SETUP
# https://www.debian.org/doc/debian-policy/ch-source.html
# nocheck: This tag says to not run any build-time test suite provided by the package.
export DEB_BUILD_OPTIONS=nocheck

# Setup of $(arch), $(rockruby_libdir) and $(rockruby_archdir)
arch=$(shell gcc -print-multiarch)
ruby_ver=$(shell ruby --version)
ruby_arch_dir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['archdir']")
ruby_libdir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['rubylibdir']")
rockruby_archdir=$(subst /usr,,$(ruby_arch_dir))
rockruby_libdir=$(subst /usr,,$(ruby_libdir))
# Setup of paths: PATH,PKG_CONFIG_PATH,RUBYLIB,...
master2001_install_dir = /opt/rock/master-20.01
env_setup =  PATH=$(master2001_install_dir)/bin:$(PATH)
env_setup += HOME=/home/ 
env_setup += RUBYLIB=$(master2001_install_dir)/$(rockruby_libdir):$(master2001_install_dir)/$(rockruby_archdir):$(master2001_install_dir)/lib/ruby/vendor_ruby/standard:$(master2001_install_dir)/lib/ruby/vendor_ruby/core:$(master2001_install_dir)/lib/ruby/vendor_ruby:$(RUBYLIB)
env_setup += PKG_CONFIG_PATH=$(master2001_install_dir)/lib/pkgconfig:$(master2001_install_dir)/lib/$(arch)/pkgconfig:/usr/share/pkgconfig:/usr/lib/$(arch)/pkgconfig:$(PKG_CONFIG_PATH)
env_setup += Rock_DIR=$(master2001_install_dir)/share/rock/cmake:$(Rock_DIR)
env_setup += LD_LIBRARY_PATH=$(master2001_install_dir)/lib:$(master2001_install_dir)/lib/$(arch):$(LD_LIBRARY_PATH)
env_setup += CMAKE_PREFIX_PATH=$(master2001_install_dir):$(CMAKE_PREFIX_PATH)
env_setup += OROGEN_PLUGIN_PATH=$(master2001_install_dir)/share/orogen/plugins:$(OROGEN_PLUGIN_PATH)
export TYPELIB_CXX_LOADER=castxml
export DEB_CPPFLAGS_APPEND=-std=c++11
export npm_config_cache=/tmp/npm
rock_library_dirs=$(master2001_install_dir)/lib:$(master2001_install_dir)/lib/$(arch):
rock_install_dir=/opt/rock/master-20.01
# Check if a python command is available and identify the version
# and identify the setup.py file
python_cmd=$(shell command -v python 2> /dev/null)
ifneq ("$(python_cmd)","")
python_version=$(shell python -c 'import sys; print "{0}.{1}".format(sys.version_info[0],sys.version_info[1])')
# Get dirname a setup.py match
python_setup_dir=$(shell find $(DEB_SRCDIR) -name setup.py | tail -n 1 | xargs dirname)
endif

DEB_VERBOSE_ALL=1
include /usr/share/cdbs/1/rules/debhelper.mk
extra_lib_dir=$(shell pwd)/debian/rock-master-20.01-slam-hogman$(rock_install_dir)/lib
# This argument list is forwarded to dh_shlibdeps which takes the -l option and a colon separated list of libraries
# (not that this is different from the linker arguments)
DEB_DH_SHLIBDEPS_ARGS_ALL=-l$(extra_lib_dir):$(extra_lib_dir)/$(arch):$(rock_library_dirs)

rock_doc_install_dir=$(rock_install_dir)/share/doc/rock-master-20.01-slam-hogman

pre-build::
	echo "Detected:"
	echo "   ruby version: $(ruby_ver)"
	echo "   ruby libdir: $(rockruby_libdir)"
	echo "   ruby archdir: $(rockruby_archdir)"

	#echo "Current directory:"
	#find .

# END ENVIRONMENT SETUP
######################################
# BEGIN OROGEN -- This block needs to be executed before CMAKE


# END OROGEN
######################################
# BEGIN CMAKE
#
# Defining the cmake command and setting the required enviroment variables
# PKG_CONFIG_PATH Resolve Rock package via pkg-config
# Rock_DIR Set to make sure find_package(Rock) does work
# ROCK_CMAKE_MACROS Used in some patches to set the CMAKE_MODULE_PATH, allowing to find Rock.cmake
CMAKE = $(env_setup) cmake
DEB_CMAKE_INSTALL_PREFIX = $(rock_install_dir)

# Debian packaging discourages the use of rpath, but
# cdbs actively sets CMAKE_SKIP_RPATH=ON, so reinforcing OFF here
DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_SKIP_RPATH=OFF
# Telling FindGEM.cmake to search for os packages using pkg-config and not for gems
DEB_CMAKE_EXTRA_FLAGS += -DGEM_OS_PKG=TRUE
# Leaving RUBY_EXECUTABLE unset since it maps to a path of the user executing the upload script
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_EXPORT_COMPILE_COMMANDS="ON" -DROCK_USE_CXX11="ON"
# Disable ROCK Testing -- since running test on the OBS would require proper setting of path, etc. (see. data_processing/type_to_vector)
DEB_CMAKE_EXTRA_FLAGS += -DROCK_TEST_ENABLED=OFF -UROCK_TEST_LOG_DIR
include /usr/share/cdbs/1/class/cmake.mk

# END CMAKE
##########################################
# BEGIN AUTOTOOLS
#


# http://cdbs-doc.duckcorp.org/en/cdbs-doc.xhtml see post-configure actions
# replace all entries of -I with -I and -isystem in order to 
#   (a) guarantee that pkgconfig can still knowns the include directory (-I)
#   (b) the include directory is actually accounted for as system include directory (-isystem)
# Account for the fact, that configure is called multiple times e.g. revert changes first, then reapply
configure/rock-master-20.01-slam-hogman::
	echo "Adapt -I to -isystem in pkgconfig files:"
	find . -name '[a-zA-Z]*.pc' -exec sh -c "echo Adapting {}; sed -i 's#\(\"\?\)-isystem[^ ]\+\1##g; s#\(\"\?\)-I\([^ ]\+\)\1#\1-I\2\1 \1-isystem\2\1#g; s#[ ]\+# #g' {}; cat {};" \;
	find . -name '[a-zA-Z]*.pc' -exec sh -c "echo Cleanup {}; sed -i 's#-isystem/usr/include # #g' {}; sed -i 's#-I/usr/include # #g' {}; cat {}" \;

###########################################
# DOCS


# Build docs
# This checks for Doxyfile and runs doxygen with that.
# Otherwise, it tries the "doc" target.
# Since docs are not critical, ignore failures('-' on recipe line start).
# The make call is supposed to be invoked even if -t or -n is selected,
# with the appropriate flags('+' on recipe line start)

common-build-arch common-build-indep:: debian/stamp-rock-doc
debian/stamp-rock-doc:
	-+$(DEB_MAKE_INVOKE) doc
	touch $@

common-install-arch common-install-indep:: common-install-rock-doc install-extensions
common-install-rock-doc::
	mkdir -p $(DEB_DESTDIR)$(rock_doc_install_dir)
	$(if $(wildcard $(DEB_SRCDIR)/doc/html),-cp -r "$(DEB_SRCDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_SRCDIR)/doc),-cp -r "$(DEB_SRCDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))
	$(if $(wildcard $(DEB_BUILDDIR)/doc/html),-cp -r "$(DEB_BUILDDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_BUILDDIR)/doc),-cp -r "$(DEB_BUILDDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))

install-extensions:: install-python
install-python::
ifneq ("$(python_setup_dir)","")
	echo "Installing python extension in $(python_setup_dir)"
	mkdir -p $(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages
	cd $(python_setup_dir); $(python_cmd) setup.py build; PYTHONPATH=$(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages/ $(python_cmd) setup.py install --prefix=$(DEB_DESTDIR)$(rock_install_dir); cd -
endif

clean::
	rm -f debian/stamp-rock-doc
	rm -rf $(DEB_SRCDIR)/doc/html


# END DOCS
###########################################
